

!DEC$	OPTIONS /ALIGN=(COMMONS=PACKED,RECORDS=PACKED)
!DEC$	END OPTIONS

!DEC$ DEFINE v83_format		! DEFINE for V8.3 and above formats
*****!DEC$ UNDEFINE v83_format	! undefine for before V8.3
*****!DEC$ DEFINE v5x_format		! DEFINE v5x_format for V5.x to V8.2 formats
*****!DEC$ UNDEFINE v5x_format	! undefine for before V8.3 and after V5.x

C*
C*	Set up the Process State Symbolic Codes which have been taken
C*	from SYS$SHARE:LIB.MLB.
C*
	PARAMETER	SCH$C_COLPG	=	1
	PARAMETER	SCH$T_COLPG	=	'Collided Page Wait'
	PARAMETER	SCH$C_MWAIT	=	2
	PARAMETER	SCH$T_MWAIT	=	'Mutext & Misc. Wait'
	PARAMETER	SCH$C_CEF	=	3
	PARAMETER	SCH$T_CEF	=	'Common Event Flag Wait'
	PARAMETER	SCH$C_PFW	=	4
	PARAMETER	SCH$T_PFW	=	'Page Fault Wait'
	PARAMETER	SCH$C_LEF	=	5
	PARAMETER	SCH$T_LEF	=	'Local Event Flag Wait'
	PARAMETER	SCH$C_LEFO	=	6
	PARAMETER	SCH$T_LEFO	=	'LEF Wait, Out of Balance Set'
	PARAMETER	SCH$C_HIB	=	7
	PARAMETER	SCH$T_HIB	=	'Hibernate Wait'
	PARAMETER	SCH$C_HIBO	=	8
	PARAMETER	SCH$T_HIBO	=	'Hibernate, Out of Balance Set'
	PARAMETER	SCH$C_SUSP	=	9
	PARAMETER	SCH$T_SUSP	=	'Suspended'
	PARAMETER	SCH$C_SUSPO	=	10
	PARAMETER	SCH$T_SUSPO	=	'Suspended, Out of Balance Set'
	PARAMETER	SCH$C_FPG	=	11
	PARAMETER	SCH$T_FPG	=	'Free Page Wait'
	PARAMETER	SCH$C_COM	=	12
	PARAMETER	SCH$T_COM	=	'Computable'
	PARAMETER	SCH$C_COMO	=	13
	PARAMETER	SCH$T_COMO	=	'Computable, Out of Balance Set'
	PARAMETER	SCH$C_CUR	=	14
	PARAMETER	SCH$T_CUR	=	'Current'

C*	Set up the Miscellaneous Wait Symbolic Codes which have been
C*	taken from SYS$SHARE:LIB.MLB.
C*
C*	AST Wait (Wait for AST)
	PARAMETER	RSN$_ASTWAIT	= 	1
	PARAMETER	RSN$T_ASTWAIT	=
	1		'RWAST - AST Wait (system or special kernel AST)'
C*	Mailbox Full
	PARAMETER	RSN$_MAILBOX	=	2
	PARAMETER	RSN$T_MAILBOX	=	'RWMBX - Mailbox Full'
C*	Nonpaged Dynamic Memory
	PARAMETER	RSN$_NPDYNMEM	=	3
	PARAMETER	RSN$T_NPDYNMEM	=
	1			'RWNPG - Nonpaged Dynamic Memory'
C*	Page File Full
	PARAMETER	RSN$_PGFILE	=	4
	PARAMETER	RSN$T_PGFILE	=	'RWPGF - Page File Full'
C*	Paged Dynamic Memory
	PARAMETER	RSN$_PGDYNMEM	=	5
	PARAMETER	RSN$T_PGDYNMEM	=	'RWPAG - Paged Dynamic Memory'
C*	Breakthru
	PARAMETER	RSN$_BRKTHRU	=	6
	PARAMETER	RSN$T_BRKTHRU	=
	1		'RWBRK - Breakthrough (wait for broadcast message)'
C*	Image Activation Lock
	PARAMETER	RSN$_IACLOCK	=	7
	PARAMETER	RSN$T_IACLOCK	=	'RWIMG - Image Activation Lock'
C*	Job Pooled Quota
	PARAMETER	RSN$_JQUOTA	=	8
	PARAMETER	RSN$T_JQUOTA	=	'RWQUEO - Job Pooled Quota'
C*	Lock Data Base
	PARAMETER	RSN$_LOCKID	=	9
	PARAMETER	RSN$T_LOCKID	=	'RWLCK - Lock Data Base'
C*	Swap File Space
	PARAMETER	RSN$_SWPFILE	=	10
	PARAMETER	RSN$T_SWPFILE	=	'RWSWP - Swap File Space'
C*	Modified Page List Empty
	PARAMETER	RSN$_MPLEMPTY	=	11
	PARAMETER	RSN$T_MPLEMPTY	=
	1		'RWMPE - Modified Page List Empty'
C*	Modified Page Writer Busy
	PARAMETER	RSN$_MPWBUSY	=	12
	PARAMETER	RSN$T_MPWBUSY	=
	1		'RWMPB - Modified Page Writer Busy'
C*	System Communication Server wait
	PARAMETER	RSN$_SCS	=	13
	PARAMETER	RSN$T_SCS	=
	1		'RWSCS - System Communication Server wait'
C*	Cluster State Transition wait
	PARAMETER	RSN$_CLUSTRAN	=	14
	PARAMETER	RSN$T_CLUSTRAN	=
	1		'RWCLU - Cluster State Transition wait'
C*	CPU Capability
	PARAMETER	RSN$_CPUCAP	=	15
	PARAMETER	RSN$T_CPUCAP	=	'RWCAP - CPU Capability'
C*	Cluster Server Process
	PARAMETER	RSN$_CLUSRV	=	16
	PARAMETER	RSN$T_CLUSRV	=
	1		'RWCSV - Cluster Server Process'
C*

C*	PCB masks to test agains MNR_PRO$L_STS to get /SUMMARY counts
	PARAMETER	PCB$M_BATCH 	=	16384
	PARAMETER	PCB$M_NETWRK	=	2097152
	PARAMETER	PCB$M_INTER 	=	33554432


C*
C*	Set up the record types that we have in a monitor recording file
C*
	BYTE		MNR_HDR$_TYPE,
	1		MNR_SYI$_TYPE,
	2		MNR_NTR$_TYPE,
	3		MNR_FIL$_TYPE

	PARAMETER	(MNR_HDR$_TYPE	=	128)
	PARAMETER	(MNR_SYI$_TYPE	=	129)
	PARAMETER	(MNR_NTR$_TYPE	=	130)
	PARAMETER	(MNR_FIL$_TYPE	=	131)

	PARAMETER	MNR_PRO$_TYPE	=	0
	PARAMETER	MNR_STA$_TYPE	=	1
	PARAMETER	MNR_MOD$_TYPE	=	2
	PARAMETER	MNR_PAG$_TYPE	=	3
	PARAMETER	MNR_IO$_TYPE	=	4
	PARAMETER	MNR_FCP$_TYPE	=	5
	PARAMETER	MNR_POO$_TYPE	=	6
	PARAMETER	MNR_LCK$_TYPE	=	7
	PARAMETER	MNR_NET$_TYPE	=	8
	PARAMETER	MNR_FLI$_TYPE	=	11
	PARAMETER	MNR_DSK$_TYPE	=	12
	PARAMETER	MNR_DLO$_TYPE	=	14
	PARAMETER	MNR_SCS$_TYPE	=	15
	PARAMETER	MNR_SYS$_TYPE	=	17
	PARAMETER	MNR_CLU$_TYPE	=	19
	PARAMETER	MNR_RMS$_TYPE	=	20
	PARAMETER	MNR_MSC$_TYPE	=	21


C*
C*	Build the record structure
C*
	STRUCTURE /FILE_HEADER/
	    UNION
	    MAP
!DEC$ IF DEFINED (v83_format)
                CHARACTER*260	OVERLAY
!DEC$ ELSE
		CHARACTER*256	OVERLAY
!DEC$ ENDIF

	    END MAP
	    MAP
		BYTE		MNR_HDR$B_TYPE
		INTEGER*4	MNR_HDR$L_FLAGS
!DEC$ IF DEFINED (v83_format)
                CHARACTER*3	mnr_hdr$t_fill_0
!DEC$ ENDIF
		INTEGER*4	MNR_HDR$Q_BEGINNING(2)
		INTEGER*4	MNR_HDR$Q_ENDING(2)
		INTEGER*4	MNR_HDR$L_INTERVAL
!DEC$ IF DEFINED (v83_format)
                CHARACTER*4	mnr_hdr$t_fill_1
!DEC$ ENDIF
		INTEGER*4	MNR_HDR$O_REVOCLSBITS(4)
		INTEGER*4	MNR_HDR$L_RECCT
		CHARACTER*8	MNR_HDR$T_IDENT
		CHARACTER*60	MNR_HDR$T_COMMENT
		INTEGER*2	MNR_HDR$W_COMLEN
!DEC$ IF DEFINED (v83_format)
                CHARACTER*2	mnr_hdr$t_fill_2
!DEC$ ENDIF
		INTEGER*4	MNR_HDR$O_CLASSBITS
		CHARACTER*128	MNR_HDR$T_REVLEVELS
	    END MAP
	    END UNION
	END STRUCTURE

	STRUCTURE /SYSTEM_INFO/
	    UNION
	    MAP
!DEC$ IF DEFINED (v83_format)
                CHARACTER*60	OVERLAY
!DEC$ ELSE
		CHARACTER*52	OVERLAY
!DEC$ ENDIF
	    END MAP
	    MAP
		BYTE		MNR_SYI$B_TYPE
!DEC$ IF DEFINED (v83_format)
		byte		mnr_syi$b_spare2
!DEC$ ENDIF
		INTEGER*2	MNR_SYI$W_FLAGS
!DEC$ IF DEFINED (v83_format)
		byte		mnr_syi$b_fill_4(4)
!DEC$ ENDIF
		INTEGER*4	MNR_SYI$Q_BOOTTIME(2)
		INTEGER*2	MNR_SYI$W_MAXPRCCNT
		BYTE		MNR_SYI$B_MPCPUS
!DEC$ IF DEFINED (v83_format)
		byte		mnr_syi$b_fill_5(5)
!DEC$ ENDIF
		CHARACTER*16	MNR_SYI$T_NODENAME
		INTEGER*4	MNR_SYI$L_BALSETMEM
		INTEGER*4	MNR_SYI$L_MPWHILM
		INTEGER*4	MNR_SYI$L_CPUTYPE
		BYTE		MNR_SYI$B_INDEX
		INTEGER*2	MNR_SYI$L_CPUCONF
		BYTE		MNR_SYSI$L_VPCPUS
		INTEGER*2	MNR_SYSI$L_VPCONF

	    END MAP
	    END UNION
	END STRUCTURE

C*
C*		Note that the following record types have not
C*		been described in this program but are shown
C*		in appendix A of the Monitor Utility Book;
C*
C*			RMS,
C*			CLUSTER,
C*			DECNET,
C*			DISK,
C*			DLOCK,
C*			FCP,
C*			FILE_SYSTEM_CACHE,
C*			IO,
C*			LOCK,
C*			MODES,
C*			MSCP_SERVER,
C*			PAGE,
C*			POOL,
C*			RMS_CLASS,
C*			SCS,
C*			STATES,
C*			SYSTEM
C*

	STRUCTURE /CLASS_HEADER/
	    UNION
	    MAP
!DEC$ IF DEFINED (v83_format)
		character*16	overlay
!DEC$ ELSE
		CHARACTER*13	OVERLAY
!DEC$ ENDIF
	    END MAP
	    MAP
		BYTE		MNR_CLS$B_TYPE
		BYTE		MNR_CLS$B_FLAGS
		BYTE		MNR_CLS$B_INDEX
!DEC$ IF DEFINED (v83_format)
		byte		mnr_cls$b_fill_12
		INTEGER*2	MNR_CLS$W_RESERVED
		character*2	mnr_cls$b_fill_13
		INTEGER*4	MNR_CLS$Q_STAMP(2)
!DEC$ ELSE
		INTEGER*4	MNR_CLS$Q_STAMP(2)
		INTEGER*2	MNR_CLS$W_RESERVED
!DEC$ ENDIF

	    END MAP
	    END UNION
	END STRUCTURE

	STRUCTURE /CLASS_PREFIX/
	    UNION
	    MAP
		CHARACTER*8	OVERLAY
	    END MAP
	    MAP
		INTEGER*4	MNR_CMP$L_ELTCT
		INTEGER*4	MNR_CMP$L_PCTINT
	    END MAP
	    END UNION
	END STRUCTURE

	STRUCTURE /PROCESS/
	    UNION
	    MAP
!DEC$ IF DEFINED (v83_format)
		character*96	OVERLAY
!DEC$ ELSE IF DEFINED (v5x_format)
		CHARACTER*72	OVERLAY
!DEC$ ELSE
		CHARACTER*67	OVERLAY
!DEC$ ENDIF
	    END MAP
	    MAP
		INTEGER*4	MNR_PRO$L_PID
		UNION
			MAP
				INTEGER*4	MNR_PRO$L_UIC
			END MAP
			MAP
				INTEGER*2	MNR_PRO$W_UIC_MEM
				INTEGER*2	MNR_PRO$W_UIC_GRP
			END MAP
		END UNION
		INTEGER*2	MNR_PRO$W_STATE
		BYTE		MNR_PRO$B_PRI
!DEC$ IF DEFINED (v83_format)
		character*5	mnr_proc$b_fill_24
!DEC$ ENDIF

		CHARACTER*16	MNR_PRO$T_LNAME
		INTEGER*4	MNR_PRO$L_GPGCNT
		INTEGER*4	MNR_PRO$L_PPGCNT
		INTEGER*4	MNR_PRO$L_STS
		INTEGER*4	MNR_PRO$L_DIOCNT
		INTEGER*4	MNR_PRO$L_PAGEFLTS
		INTEGER*4	MNR_PRO$L_CPUTIM
		INTEGER*4	MNR_PRO$L_BIOCNT
		INTEGER*4	MNR_PRO$L_EPID
		INTEGER*4	MNR_PRO$L_EFWM
!DEC$ IF DEFINED (v5x_format)
		INTEGER*4	MNR_PRO$L_RBSTRAN
		CHARACTER*5	MNR_PRO$B_FILL_25
!DEC$ ENDIF
!DEC$ IF DEFINED (v83_format)
		integer*4	mnr_pro$l_rbstran
		integer*4	mnr_pro$l_kernel_counter
		integer*4	mnr_pro$l_executive_counter
		integer*4	mnr_pro$l_supervisor_counter
		integer*4	mnr_pro$l_user_counter
		integer*4	mnr_pro$l_reserved2
		integer*4	mnr_pro$l_reserved1
!DEC$ ENDIF

	    END MAP
	    END UNION
	END STRUCTURE

	RECORD /FILE_HEADER/FILE_HEADER_REC
	RECORD /SYSTEM_INFO/SYSTEM_INFO_REC
	RECORD /CLASS_HEADER/CLASS_HEADER_REC
	RECORD /CLASS_PREFIX/CLASS_PREFIX_REC
	RECORD /PROCESS/PROCESS_REC

	CHARACTER*80	BEGINNING_TEXT,
	2		ENDING_TEXT
	CHARACTER*60	COMMENT
	CHARACTER*15	NODE

	LOGICAL COLPG,MWAIT,CEF,PFW,LEF,LEFO,HIB,HIBO,
	1		SUSP,SUSPO,FPG,COM,COMO,CUR,SUMMARY

	INTEGER*4	COMPUTE_COUNT_VALUE,
	1		LINE_COUNT,
	2		INTERVAL,
	3		BEGINNING_LEN,
	4		ENDING_LEN,
	5		TIME_LEN

	INTEGER*2	NODE_LENGTH,
	1		COMMENT_LEN

	COMMON /mwait_common/
	1		COMPUTE_COUNT_VALUE,		! integer*4
	2		LINE_COUNT,			! integer*4
	3		INTERVAL,			! integer*4
	4		BEGINNING_LEN, ENDING_LEN,
	5		TIME_LEN,
	6		NODE_LENGTH,COMMENT_LEN,
	7		COLPG,MWAIT,CEF,PFW,LEF,LEFO,HIB,HIBO,	! Logical
	8		SUSP,SUSPO,FPG,COM,COMO,CUR,SUMMARY,	! Logical
	9		COMMENT,BEGINNING_TEXT,ENDING_TEXT,NODE
